	/*534:*/
%{
	#line 11076 "format.w"
	
#include "basetypes.h"
#include <string.h>
#include <math.h>
#include "error.h"
#include "format.h"
#include "put.h"
extern char**hfont_name;

	/*375:*/
uint32_t definition_bits[0x100/32][32]= {
	#line 8279 "format.w"
	{0}};

#define SET_DBIT(N,K) ((N)>0xFF?1:(definition_bits[N/32][K]	|= (1<<((N)&(32-1)))))
#define GET_DBIT(N,K) ((N)>0xFF?1:((definition_bits[N/32][K]>>((N)&(32-1)))&1))
#define DEF(D,K,N) (D).k= K; (D).n= (N);SET_DBIT((D).n,(D).k);\
 DBG(DBGDEF,"Defining %s %d\n",definition_name[(D).k],(D).n);\
 RNG("Definition",(D).n,max_fixed[(D).k]+1,max_ref[(D).k]);
#define REF(K,N) REF_RNG(K,N);if(!GET_DBIT(N,K)) \
 QUIT("Reference %d to %s before definition",(N),definition_name[K])
	/*:375*/	/*379:*/
#define DEF_REF(D,K,M,N)  DEF(D,K,M);\
if ((int)(M)>max_default[K]) QUIT("Defining non default reference %d for %s",M,definition_name[K]); \
if ((int)(N)>max_fixed[K]) QUIT("Defining reference %d for %s by non fixed reference %d",M,definition_name[K],N);
	/*:379*/

extern void hset_entry(Entry*e,uint16_t i,uint32_t size,
uint32_t xsize,char*file_name);

	/*445:*/
#ifdef DEBUG
#define  YYDEBUG 1
extern int yydebug;
#else
#define YYDEBUG 0
#endif
	/*:445*/
extern int yylex(void);

	/*371:*/
void hset_max(Kind k,int n)
{
	#line 8121 "format.w"
	DBG(DBGDEF,"Setting max %s to %d\n",definition_name[k],n);
	RNG("Maximum",n,max_fixed[k]+1,MAX_REF(k));
	if(n>max_ref[k])
	max_ref[k]= n;
	}
	/*:371*/	/*382:*/
void check_param_def(Ref*df)
{
	#line 8432 "format.w"
	if(df->k!=int_kind&&df->k!=dimen_kind&&df->k!=glue_kind)
	QUIT("Kind %s not allowed in parameter list",definition_name[df->k]);
	if(df->n<=max_fixed[df->k]||max_default[df->k]<df->n)
	QUIT("Parameter %d for %s not allowed in parameter list",df->n,definition_name[df->k]);
	}
	/*:382*/	/*444:*/
extern int yylineno;
int yyerror(const char*msg)
{
	#line 9572 "format.w"
	QUIT(" in line %d %s",yylineno,msg);
	return 0;
	}
	/*:444*/


%}





%union {
	#line 11101 "format.w"
	uint32_t u;  int32_t i;  char *s;  float64_t f;  Glyph c;
	Dimen d;Stretch st;Xdimen xd;Kern kt;
	Rule r;Glue g;Image x;
	List l;Box h;Disc dc;Lig lg;
	Ref rf;Info info;Order o;bool b;
	}



%error_verbose
%start hint

	/*2:*/
%token START    "<"
%token END      ">"
%token GLYPH     "glyph"
%token <u> UNSIGNED
%token <u> REFERENCE
	/*:2*/	/*4:*/
%type <u> start
%type <c> glyph
	/*:4*/	/*27:*/
%token <i> SIGNED
%type <i> integer
	/*:27*/	/*34:*/
%token <s> STRING
	/*:34*/	/*48:*/
%token <u> CHARCODE
	/*:48*/	/*50:*/
%type <s> string
	/*:50*/	/*55:*/
%token <f> FPNUM
%type <f> number
	/*:55*/	/*80:*/
%token DIMEN "dimen"
%token PT "pt"
%token MM "mm"
%token INCH "in"
%type <d> dimension
	/*:80*/	/*88:*/
%token XDIMEN "xdimen"
%token H "h"
%token V "v"
%type <xd> xdimen
	/*:88*/	/*99:*/
%token FIL "fil"
%token FILL "fill"
%token FILLL "filll"
%type <st> stretch
%type <o> order
	/*:99*/	/*103:*/
%token PENALTY "penalty"
%token INTEGER     "int"
%type <i> penalty
	/*:103*/	/*109:*/
%token LANGUAGE "language"
	/*:109*/	/*115:*/
%token RULE "rule"
%token RUNNING "|"
%type <d> rule_dimension
%type <r> rule
	/*:115*/	/*124:*/
%token KERN "kern"
%token EXPLICIT "!"
%type <b> explicit
%type <kt> kern
	/*:124*/	/*133:*/
%token GLUE "glue"
%token PLUS  "plus"
%token MINUS   "minus"
%type <g> glue
%type <b> glue_node
%type <st> plus minus
	/*:133*/	/*142:*/
%type <l>  list
%type <u> position content_list
	/*:142*/	/*151:*/
%token TXT_START TXT_END TXT_IGNORE
%token TXT_FONT_GLUE TXT_FONT_HYPHEN
%token <u> TXT_FONT TXT_LOCAL
%token <rf> TXT_GLOBAL
%token <u> TXT_CC
%type <u> text
	/*:151*/	/*161:*/
%token HBOX     "hbox"
%token VBOX     "vbox"
%token SHIFTED  "shifted"
%type <info> box box_dimen box_shift box_glue_set

	/*:161*/	/*169:*/
%token HPACK "hpack"
%token HSET  "hset"
%token VPACK "vpack"
%token VSET  "vset"
%token DEPTH "depth"
%token ADD "add"
%token TO "to"
%type <info> box_options box_goal hpack vpack vbox_dimen
%type <d> max_depth
	/*:169*/	/*174:*/
%token LEADERS "leaders"
%token ALIGN "align"
%token CENTER "center"
%token EXPAND "expand"
%type <info> leaders
%type <info> ltype
	/*:174*/	/*181:*/
%token BASELINE "baseline"
%type <info> baseline
	/*:181*/	/*188:*/
%token LIGATURE     "ligature"
%type <u>  lig_cc
%type <lg> ligature
%type <u> ref
	/*:188*/	/*196:*/
%token DISC     "disc"
%type <dc> disc
%type <u> replace_count
	/*:196*/	/*204:*/
%token PAR "par"
%type <info> par
	/*:204*/	/*209:*/
%token MATH "math"
%type <info> math
	/*:209*/	/*214:*/
%token ON "on"
%token OFF "off"
%type <i> on_off
	/*:214*/	/*218:*/
%token ADJUST "adjust"
	/*:218*/	/*222:*/
%token TABLE "table"
%token ITEM "item"
%type <info> table span_count
	/*:222*/	/*229:*/
%token IMAGE "image"
%token WIDTH "width"
%token HEIGHT "height"
%type <xd> image_width image_height
%type <f> image_aspect
%type <info> image_spec image
	/*:229*/	/*254:*/
%token LABEL "label"
%token BOT "bot"
%token MID "mid"
%type <i> placement
	/*:254*/	/*268:*/
%token LINK "link"
	/*:268*/	/*278:*/
%token OUTLINE "outline"
	/*:278*/	/*285:*/
%token UNKNOWN    "unknown"
	/*:285*/	/*288:*/
%type  <u> unknown_bytes
%type  <u> unknown_nodes
	/*:288*/	/*294:*/
%token STREAM "stream"
%token STREAMDEF "stream (definition)"
%token FIRST "first"
%token LAST "last"
%token TOP "top"
%token NOREFERENCE "*"
%type <info> stream_type
%type <u> stream_ref
%type <rf> stream_def_node
	/*:294*/	/*300:*/
%type <info> stream
	/*:300*/	/*304:*/
%token PAGE "page"
	/*:304*/	/*312:*/
%token RANGE "range"
	/*:312*/	/*339:*/
%token DIRECTORY "directory"
%token SECTION "entry"
	/*:339*/	/*360:*/
%token DEFINITIONS "definitions"
	/*:360*/	/*368:*/
%token MAX "max"
	/*:368*/	/*377:*/

%type <rf> def_node
	/*:377*/	/*383:*/
%token PARAM "param"
%type <u> def_list
%type <l> parameters
	/*:383*/	/*392:*/
%token FONT     "font"
%type <info> font font_head
	/*:392*/	/*423:*/
%token CONTENT "content"
	/*:423*/
%%
	/*5:*/
glyph:UNSIGNED REFERENCE{
	#line 424 "format.w"
	$$.c= $1;REF(font_kind,$2);$$.f= $2;};
content_node:start GLYPH glyph END{
	#line 425 "format.w"
	hput_tags($1,hput_glyph(&($3)));};
start:START{
	#line 426 "format.w"
	HPUTNODE;$$= (uint32_t)(hpos++-hstart);}
	/*:5*/	/*30:*/
integer:SIGNED	|UNSIGNED{
	#line 954 "format.w"
	RNG("number",$1,0,0x7FFFFFFF);};
	/*:30*/	/*39:*/
glyph:CHARCODE REFERENCE{
	#line 1096 "format.w"
	$$.c= $1;REF(font_kind,$2);$$.f= $2;};
	/*:39*/	/*51:*/
string:STRING	|CHARCODE{
	#line 1201 "format.w"
	static char s[2];
	RNG("String element",$1,0x20,0x7E);
	s[0]= $1;s[1]= 0;$$= s;};
	/*:51*/	/*59:*/
number:UNSIGNED{
	#line 1354 "format.w"
	$$= (float64_t)$1;}	|SIGNED{
	#line 1354 "format.w"
	$$= (float64_t)$1;}	|FPNUM;
	/*:59*/	/*83:*/
dimension:number PT{
	#line 1708 "format.w"
	$$= ROUND($1*ONE);RNG("Dimension",$$,-MAX_DIMEN,MAX_DIMEN);}
	|number INCH{
	#line 1709 "format.w"
	$$= ROUND($1*ONE*72.27);RNG("Dimension",$$,-MAX_DIMEN,MAX_DIMEN);}
	|number MM{
	#line 1710 "format.w"
	$$= ROUND($1*ONE*(72.27/25.4));RNG("Dimension",$$,-MAX_DIMEN,MAX_DIMEN);};
	/*:83*/	/*90:*/
xdimen:dimension number H number V{
	#line 1788 "format.w"
	$$.w= $1;$$.h= $2;$$.v= $4;}
	|dimension number H{
	#line 1789 "format.w"
	$$.w= $1;$$.h= $2;$$.v= 0.0;}
	|dimension number V{
	#line 1790 "format.w"
	$$.w= $1;$$.h= 0.0;$$.v= $2;}
	|dimension{
	#line 1791 "format.w"
	$$.w= $1;$$.h= 0.0;$$.v= 0.0;};

xdimen_node:start XDIMEN xdimen END{
	#line 1793 "format.w"
	hput_tags($1,hput_xdimen(&($3)));};
	/*:90*/	/*101:*/

order:PT{
	#line 1972 "format.w"
	$$= normal_o;}	|FIL{
	#line 1972 "format.w"
	$$= fil_o;}	|FILL{
	#line 1972 "format.w"
	$$= fill_o;}	|FILLL{
	#line 1972 "format.w"
	$$= filll_o;};

stretch:number order{
	#line 1974 "format.w"
	$$.f= $1;$$.o= $2;};
	/*:101*/	/*105:*/
penalty:integer{
	#line 2028 "format.w"
	RNG("Penalty",$1,-20000,+20000);$$= $1;};
content_node:start PENALTY penalty END{
	#line 2029 "format.w"
	hput_tags($1,hput_int($3));};
	/*:105*/	/*117:*/
rule_dimension:dimension	|RUNNING{
	#line 2206 "format.w"
	$$= RUNNING_DIMEN;};
rule:rule_dimension rule_dimension rule_dimension
{
	#line 2208 "format.w"
	$$.h= $1;$$.d= $2;$$.w= $3;
	if($3==RUNNING_DIMEN&&($1==RUNNING_DIMEN||$2==RUNNING_DIMEN))
	QUIT("Incompatible running dimensions 0x%x 0x%x 0x%x",$1,$2,$3);};
rule_node:start RULE rule END{
	#line 2211 "format.w"
	hput_tags($1,hput_rule(&($3)));};
content_node:rule_node;
	/*:117*/	/*126:*/
explicit:{
	#line 2319 "format.w"
	$$= false;}	|EXPLICIT{
	#line 2319 "format.w"
	$$= true;};
kern:explicit xdimen{
	#line 2320 "format.w"
	$$.x= $1;$$.d= $2;};
content_node:start KERN kern END{
	#line 2321 "format.w"
	hput_tags($1,hput_kern(&($3)));}
	/*:126*/	/*135:*/
plus:{
	#line 2531 "format.w"
	$$.f= 0.0;$$.o= 0;}	|PLUS stretch{
	#line 2531 "format.w"
	$$= $2;};
minus:{
	#line 2532 "format.w"
	$$.f= 0.0;$$.o= 0;}	|MINUS stretch{
	#line 2532 "format.w"
	$$= $2;};
glue:xdimen plus minus{
	#line 2533 "format.w"
	$$.w= $1;$$.p= $2;$$.m= $3;};
content_node:start GLUE glue END{
	#line 2534 "format.w"
	if(ZERO_GLUE($3)){HPUT8(zero_skip_no);
	hput_tags($1,TAG(glue_kind,0));}else hput_tags($1,hput_glue(&($3)));};
glue_node:start GLUE glue END
{
	#line 2537 "format.w"
	if(ZERO_GLUE($3)){hpos--;$$= false;}
	else{hput_tags($1,hput_glue(&($3)));$$= true;}};
	/*:135*/	/*143:*/
position:{
	#line 2812 "format.w"
	$$= hpos-hstart;};
content_list:position
	|content_list content_node;
estimate:{
	#line 2815 "format.w"
	hpos+= 2;}
	|UNSIGNED{
	#line 2816 "format.w"
	hpos+= hsize_bytes($1)+1;};
list:start estimate content_list END
{
	#line 2818 "format.w"
	$$.t= TAG(list_kind,b010);$$.p= $3;$$.s= (hpos-hstart)-$3;
	hput_tags($1,hput_list($1+1,&($$)));};
	/*:143*/	/*154:*/
list:TXT_START position
{
	#line 3232 "format.w"
	hpos+= 4;}
text TXT_END
{
	#line 3234 "format.w"
	$$.t= TAG(list_kind,b110);$$.p= $4;$$.s= (hpos-hstart)-$4;
	hput_tags($2,hput_list($2+1,&($$)));};
text:position	|text txt;

txt:TXT_CC{
	#line 3238 "format.w"
	hput_txt_cc($1);}
	|TXT_FONT{
	#line 3239 "format.w"
	REF(font_kind,$1);hput_txt_font($1);}
	|TXT_GLOBAL{
	#line 3240 "format.w"
	REF($1.k,$1.n);hput_txt_global(&($1));}
	|TXT_LOCAL{
	#line 3241 "format.w"
	RNG("Font parameter",$1,0,11);hput_txt_local($1);}
	|TXT_FONT_GLUE{
	#line 3242 "format.w"
	HPUTX(1);HPUT8(txt_glue);}
	|TXT_FONT_HYPHEN{
	#line 3243 "format.w"
	HPUTX(1);HPUT8(txt_hyphen);}
	|TXT_IGNORE{
	#line 3244 "format.w"
	HPUTX(1);HPUT8(txt_ignore);}
	|{
	#line 3245 "format.w"
	HPUTX(1);HPUT8(txt_node);}content_node;
	/*:154*/	/*163:*/

box_dimen:dimension dimension dimension
{
	#line 3501 "format.w"
	$$= hput_box_dimen($1,$2,$3);};
box_shift:{
	#line 3502 "format.w"
	$$= b000;}
	|SHIFTED dimension{
	#line 3503 "format.w"
	$$= hput_box_shift($2);};

box_glue_set:{
	#line 3505 "format.w"
	$$= b000;}
	|PLUS stretch{
	#line 3506 "format.w"
	$$= hput_box_glue_set(+1,$2.f,$2.o);}
	|MINUS stretch{
	#line 3507 "format.w"
	$$= hput_box_glue_set(-1,$2.f,$2.o);};


box:box_dimen box_shift box_glue_set list{
	#line 3510 "format.w"
	$$= $1	|$2	|$3;};

hbox_node:start HBOX box END{
	#line 3512 "format.w"
	hput_tags($1,TAG(hbox_kind,$3));};
vbox_node:start VBOX box END{
	#line 3513 "format.w"
	hput_tags($1,TAG(vbox_kind,$3));};
content_node:hbox_node	|vbox_node;
	/*:163*/	/*171:*/
box_flex:plus minus{
	#line 3709 "format.w"
	hput_stretch(&($1));hput_stretch(&($2));};

box_options:box_shift box_flex xdimen_ref list{
	#line 3711 "format.w"
	$$= $1;}
	|box_shift box_flex xdimen_node list{
	#line 3712 "format.w"
	$$= $1	|b100;};

hxbox_node:start HSET box_dimen box_options END{
	#line 3714 "format.w"
	hput_tags($1,TAG(hset_kind,$3	|$4));};

vbox_dimen:box_dimen
	|TOP dimension dimension dimension
{
	#line 3718 "format.w"
	$$= hput_box_dimen($2,$3^0x40000000,$4);};

vxbox_node:start VSET vbox_dimen box_options END{
	#line 3720 "format.w"
	hput_tags($1,TAG(vset_kind,$3	|$4));};

box_goal:TO xdimen_ref{
	#line 3722 "format.w"
	$$= b000;}
	|ADD xdimen_ref{
	#line 3723 "format.w"
	$$= b001;}
	|TO xdimen_node{
	#line 3724 "format.w"
	$$= b100;}
	|ADD xdimen_node{
	#line 3725 "format.w"
	$$= b101;};

hpack:box_shift box_goal list{
	#line 3727 "format.w"
	$$= $2;};

hxbox_node:start HPACK hpack END{
	#line 3729 "format.w"
	hput_tags($1,TAG(hpack_kind,$3));};

max_depth:{
	#line 3731 "format.w"
	$$= MAX_DIMEN;}	|MAX DEPTH dimension{
	#line 3731 "format.w"
	$$= $3;};

vpack:max_depth{
	#line 3733 "format.w"
	HPUT32($1);}box_shift box_goal list{
	#line 3733 "format.w"
	$$= $3	|$4;}
	|TOP max_depth{
	#line 3734 "format.w"
	HPUT32($2^0x40000000);}box_shift box_goal list{
	#line 3734 "format.w"
	$$= $4	|$5;};

vxbox_node:start VPACK vpack END{
	#line 3736 "format.w"
	hput_tags($1,TAG(vpack_kind,$3));};

content_node:vxbox_node	|hxbox_node;
	/*:171*/	/*176:*/
ltype:{
	#line 3850 "format.w"
	$$= 1;}	|ALIGN{
	#line 3850 "format.w"
	$$= 1;}	|CENTER{
	#line 3850 "format.w"
	$$= 2;}	|EXPAND{
	#line 3850 "format.w"
	$$= 3;};
leaders:glue_node ltype rule_node{
	#line 3851 "format.w"
	if($1)$$= $2	|b100;else $$= $2;}
	|glue_node ltype hbox_node{
	#line 3852 "format.w"
	if($1)$$= $2	|b100;else $$= $2;}
	|glue_node ltype vbox_node{
	#line 3853 "format.w"
	if($1)$$= $2	|b100;else $$= $2;};
content_node:start LEADERS leaders END{
	#line 3854 "format.w"
	hput_tags($1,TAG(leaders_kind,$3));}
	/*:176*/	/*183:*/
baseline:dimension{
	#line 3960 "format.w"
	if($1!=0)HPUT32($1);}
glue_node glue_node{
	#line 3961 "format.w"
	$$= b000;if($1!=0)$$	|= b001;
	if($3)$$	|= b100;
	if($4)$$	|= b010;
	};
content_node:start BASELINE baseline END
{
	#line 3966 "format.w"
	if($3==b000)HPUT8(0);hput_tags($1,TAG(baseline_kind,$3));};
	/*:183*/	/*190:*/
cc_list:	|cc_list TXT_CC{
	#line 4049 "format.w"
	hput_utf8($2);};
lig_cc:UNSIGNED{
	#line 4050 "format.w"
	RNG("UTF-8 code",$1,0,0x1FFFFF);$$= hpos-hstart;hput_utf8($1);};
lig_cc:CHARCODE{
	#line 4051 "format.w"
	$$= hpos-hstart;hput_utf8($1);};
ref:REFERENCE{
	#line 4052 "format.w"
	HPUT8($1);$$= $1;};
ligature:ref{
	#line 4053 "format.w"
	REF(font_kind,$1);}lig_cc TXT_START cc_list TXT_END
{
	#line 4054 "format.w"
	$$.f= $1;$$.l.p= $3;$$.l.s= (hpos-hstart)-$3;
	RNG("Ligature size",$$.l.s,0,255);};
content_node:start LIGATURE ligature END{
	#line 4056 "format.w"
	hput_tags($1,hput_ligature(&($3)));};
	/*:190*/	/*198:*/
replace_count:explicit{
	#line 4166 "format.w"
	if($1){$$= 0x80;HPUT8(0x80);}else $$= 0x00;}
	|explicit UNSIGNED{
	#line 4167 "format.w"
	RNG("Replace count",$2,0,31);
	$$= ($2)	|(($1)?0x80:0x00);if($$!=0)HPUT8($$);};
disc:replace_count list list{
	#line 4169 "format.w"
	$$.r= $1;$$.p= $2;$$.q= $3;
	if($3.s==0){hpos= hpos-3;if($2.s==0)hpos= hpos-3;}}
	|replace_count list{
	#line 4171 "format.w"
	$$.r= $1;$$.p= $2;if($2.s==0)hpos= hpos-3;$$.q.s= 0;}
	|replace_count{
	#line 4172 "format.w"
	$$.r= $1;$$.p.s= 0;$$.q.s= 0;};


disc_node:start DISC disc END
{
	#line 4176 "format.w"
	hput_tags($1,hput_disc(&($3)));};

content_node:disc_node;
	/*:198*/	/*206:*/
par_dimen:xdimen{
	#line 4328 "format.w"
	hput_xdimen_node(&($1));};
par:xdimen_ref param_ref list{
	#line 4329 "format.w"
	$$= b000;}
	|xdimen_ref param_list list{
	#line 4330 "format.w"
	$$= b010;}
	|xdimen param_ref{
	#line 4331 "format.w"
	hput_xdimen_node(&($1));}list{
	#line 4331 "format.w"
	$$= b100;}
	|par_dimen param_list list{
	#line 4332 "format.w"
	$$= b110;};

content_node:start PAR par END{
	#line 4334 "format.w"
	hput_tags($1,TAG(par_kind,$3));};
	/*:206*/	/*211:*/
math:param_ref list{
	#line 4400 "format.w"
	$$= b000;}
	|param_ref list hbox_node{
	#line 4401 "format.w"
	$$= b001;}
	|param_ref hbox_node list{
	#line 4402 "format.w"
	$$= b010;}
	|param_list list{
	#line 4403 "format.w"
	$$= b100;}
	|param_list list hbox_node{
	#line 4404 "format.w"
	$$= b101;}
	|param_list hbox_node list{
	#line 4405 "format.w"
	$$= b110;};

content_node:start MATH math END{
	#line 4407 "format.w"
	hput_tags($1,TAG(math_kind,$3));};
	/*:211*/	/*216:*/
on_off:ON{
	#line 4457 "format.w"
	$$= 1;}	|OFF{
	#line 4457 "format.w"
	$$= 0;};
math:on_off{
	#line 4458 "format.w"
	$$= b011	|($1<<2);};
	/*:216*/	/*220:*/
content_node:start ADJUST list END{
	#line 4489 "format.w"
	hput_tags($1,TAG(adjust_kind,1));};
	/*:220*/	/*224:*/
span_count:UNSIGNED{
	#line 4588 "format.w"
	$$= hput_span_count($1);};
content_node:start ITEM content_node END{
	#line 4589 "format.w"
	hput_tags($1,TAG(item_kind,1));};
content_node:start ITEM span_count content_node END{
	#line 4590 "format.w"
	hput_tags($1,TAG(item_kind,$3));};
content_node:start ITEM list END{
	#line 4591 "format.w"
	hput_tags($1,TAG(item_kind,b000));};

table:H box_goal list list{
	#line 4593 "format.w"
	$$= $2;};
table:V box_goal list list{
	#line 4594 "format.w"
	$$= $2	|b010;};

content_node:start TABLE table END{
	#line 4596 "format.w"
	hput_tags($1,TAG(table_kind,$3));};
	/*:224*/	/*231:*/
image_aspect:number{
	#line 4730 "format.w"
	$$= $1;}	|{
	#line 4730 "format.w"
	$$= 0.0;};
image_width:WIDTH xdimen{
	#line 4731 "format.w"
	$$= $2;}
	|{
	#line 4732 "format.w"
	$$= xdimen_defaults[zero_xdimen_no];};
image_height:HEIGHT xdimen{
	#line 4733 "format.w"
	$$= $2;}
	|{
	#line 4734 "format.w"
	$$= xdimen_defaults[zero_xdimen_no];};

image_spec:UNSIGNED image_aspect image_width image_height
{
	#line 4737 "format.w"
	$$= hput_image_spec($1,$2,0,&($3),0,&($4));}
	|UNSIGNED image_aspect WIDTH REFERENCE image_height
{
	#line 4739 "format.w"
	$$= hput_image_spec($1,$2,$4,NULL,0,&($5));}
	|UNSIGNED image_aspect image_width HEIGHT REFERENCE
{
	#line 4741 "format.w"
	$$= hput_image_spec($1,$2,0,&($3),$5,NULL);}
	|UNSIGNED image_aspect WIDTH REFERENCE HEIGHT REFERENCE
{
	#line 4743 "format.w"
	$$= hput_image_spec($1,$2,$4,NULL,$6,NULL);};

image:image_spec list{
	#line 4745 "format.w"
	$$= $1;};

content_node:start IMAGE image END{
	#line 4747 "format.w"
	hput_tags($1,TAG(image_kind,$3));};
	/*:231*/	/*249:*/
max_value:OUTLINE UNSIGNED{
	#line 5347 "format.w"
	max_outline= $2;
	RNG("max outline",max_outline,0,0xFFFF);
	DBG(DBGDEF	|DBGLABEL,"Setting max outline to %d\n",max_outline);
	};
	/*:249*/	/*256:*/
placement:TOP{
	#line 5439 "format.w"
	$$= LABEL_TOP;}	|BOT{
	#line 5439 "format.w"
	$$= LABEL_BOT;}	|MID{
	#line 5439 "format.w"
	$$= LABEL_MID;}	|{
	#line 5439 "format.w"
	$$= LABEL_MID;};
content_node:START LABEL REFERENCE placement END
{
	#line 5441 "format.w"
	hset_label($3,$4);}
	/*:256*/	/*270:*/
content_node:start LINK REFERENCE on_off END
{
	#line 5699 "format.w"
	hput_tags($1,hput_link($3,$4));};
	/*:270*/	/*280:*/
def_node:START OUTLINE REFERENCE integer position list END{
	#line 5829 "format.w"
	
	static int outline_no= -1;
	$$.k= outline_kind;$$.n= $3;
	if($6.s==0)QUIT("Outline with empty title in line %d",yylineno);
	outline_no++;
	hset_outline(outline_no,$3,$4,$5);
	};
	/*:280*/	/*287:*/
def_node:start UNKNOWN UNSIGNED UNSIGNED END{
	#line 5956 "format.w"
	hput_tags($1,hput_unknown_def($3,$4,0));}
	|start UNKNOWN UNSIGNED UNSIGNED UNSIGNED END{
	#line 5957 "format.w"
	hput_tags($1,hput_unknown_def($3,$4,$5));};
	/*:287*/	/*289:*/
content_node:start UNKNOWN UNSIGNED unknown_bytes unknown_nodes END{
	#line 5969 "format.w"
	hput_tags($1,hput_unknown($1,$3,$4,$5));}
unknown_bytes:{
	#line 5970 "format.w"
	$$= 0;}	|unknown_bytes UNSIGNED{
	#line 5970 "format.w"
	RNG("byte",$2,0,0xFF);HPUT8($2);$$= $1+1;};
unknown_node:content_node	|xdimen_node	|list	|named_param_list;
unknown_nodes:{
	#line 5972 "format.w"
	$$= 0;}	|unknown_nodes unknown_node{
	#line 5972 "format.w"
	RNG("unknown subnodes",$1,0,3);$$= $1+1;};
	/*:289*/	/*296:*/
stream_link:ref{
	#line 6407 "format.w"
	REF_RNG(stream_kind,$1);}	|NOREFERENCE{
	#line 6407 "format.w"
	HPUT8(255);};
stream_split:stream_link stream_link UNSIGNED{
	#line 6408 "format.w"
	RNG("split ratio",$3,0,1000);HPUT16($3);};
stream_info:xdimen_node UNSIGNED{
	#line 6409 "format.w"
	RNG("magnification factor",$2,0,1000);HPUT16($2);}stream_split;

stream_type:stream_info{
	#line 6411 "format.w"
	$$= 0;}	|FIRST{
	#line 6411 "format.w"
	$$= 1;}	|LAST{
	#line 6411 "format.w"
	$$= 2;}	|TOP{
	#line 6411 "format.w"
	$$= 3;};

stream_def_node:start STREAMDEF ref stream_type
list xdimen_node glue_node list glue_node END
{
	#line 6415 "format.w"
	DEF($$,stream_kind,$3);hput_tags($1,TAG(stream_kind,$4	|b100));};

stream_ins_node:start STREAMDEF ref END
{
	#line 6418 "format.w"
	RNG("Stream insertion",$3,0,max_ref[stream_kind]);hput_tags($1,TAG(stream_kind,b100));};

content_node:stream_def_node	|stream_ins_node;
	/*:296*/	/*301:*/
stream:param_list list{
	#line 6513 "format.w"
	$$= b010;}
	|param_ref list{
	#line 6514 "format.w"
	$$= b000;};
content_node:start STREAM stream_ref stream END
{
	#line 6516 "format.w"
	hput_tags($1,TAG(stream_kind,$4));};
	/*:301*/	/*306:*/
page_priority:{
	#line 6619 "format.w"
	HPUT8(1);}
	|UNSIGNED{
	#line 6620 "format.w"
	RNG("page priority",$1,0,255);HPUT8($1);};

stream_def_list:	|stream_def_list stream_def_node;

page:string{
	#line 6624 "format.w"
	hput_string($1);}page_priority glue_node dimension{
	#line 6624 "format.w"
	HPUT32($5);}
xdimen_node xdimen_node
list stream_def_list;
	/*:306*/	/*314:*/

content_node:START RANGE REFERENCE ON END{
	#line 6737 "format.w"
	REF(page_kind,$3);hput_range($3,true);}
	|START RANGE REFERENCE OFF END{
	#line 6738 "format.w"
	REF(page_kind,$3);hput_range($3,false);};
	/*:314*/	/*325:*/
hint:directory_section definition_section content_section;
	/*:325*/	/*341:*/
directory_section:START DIRECTORY UNSIGNED{
	#line 7431 "format.w"
	new_directory($3+1);new_output_buffers();}entry_list END;
entry_list:	|entry_list entry;
entry:START SECTION UNSIGNED string END
{
	#line 7434 "format.w"
	RNG("Section number",$3,3,max_section_no);hset_entry(&(dir[$3]),$3,0,0,$4);};
	/*:341*/	/*362:*/
definition_section:START DEFINITIONS{
	#line 7977 "format.w"
	hput_definitions_start();}
max_definitions definition_list
END{
	#line 7979 "format.w"
	hput_definitions_end();};
definition_list:	|definition_list def_node;
	/*:362*/	/*370:*/
max_definitions:START MAX max_list END
{
	#line 8095 "format.w"
		/*253:*/
	if(max_ref[label_kind]>=0)
	ALLOCATE(labels,max_ref[label_kind]+1,Label);
		/*:253*/	/*274:*/
	if(max_outline>=0)
	ALLOCATE(outlines,max_outline+1,Outline);
		/*:274*/	/*310:*/
	ALLOCATE(page_on,max_ref[page_kind]+1,int);
	ALLOCATE(range_pos,2*(max_ref[range_kind]+1),RangePos);
		/*:310*/	/*376:*/
	definition_bits[0][list_kind]= (1<<(MAX_LIST_DEFAULT+1))-1;
	definition_bits[0][param_kind]= (1<<(MAX_LIST_DEFAULT+1))-1;
	definition_bits[0][int_kind]= (1<<(MAX_INT_DEFAULT+1))-1;
	definition_bits[0][dimen_kind]= (1<<(MAX_DIMEN_DEFAULT+1))-1;
	definition_bits[0][xdimen_kind]= (1<<(MAX_XDIMEN_DEFAULT+1))-1;
	definition_bits[0][glue_kind]= (1<<(MAX_GLUE_DEFAULT+1))-1;
	definition_bits[0][baseline_kind]= (1<<(MAX_BASELINE_DEFAULT+1))-1;
	definition_bits[0][page_kind]= (1<<(MAX_PAGE_DEFAULT+1))-1;
	definition_bits[0][stream_kind]= (1<<(MAX_STREAM_DEFAULT+1))-1;
	definition_bits[0][range_kind]= (1<<(MAX_RANGE_DEFAULT+1))-1;
		/*:376*/	/*391:*/
	ALLOCATE(hfont_name,max_ref[font_kind]+1,char*);
		/*:391*/hput_max_definitions();};

max_list:	|max_list START max_value END;

max_value:FONT UNSIGNED{
	#line 8099 "format.w"
	hset_max(font_kind,$2);}
	|INTEGER UNSIGNED{
	#line 8100 "format.w"
	hset_max(int_kind,$2);}
	|DIMEN UNSIGNED{
	#line 8101 "format.w"
	hset_max(dimen_kind,$2);}
	|LIGATURE UNSIGNED{
	#line 8102 "format.w"
	hset_max(ligature_kind,$2);}
	|DISC UNSIGNED{
	#line 8103 "format.w"
	hset_max(disc_kind,$2);}
	|GLUE UNSIGNED{
	#line 8104 "format.w"
	hset_max(glue_kind,$2);}
	|LANGUAGE UNSIGNED{
	#line 8105 "format.w"
	hset_max(language_kind,$2);}
	|RULE UNSIGNED{
	#line 8106 "format.w"
	hset_max(rule_kind,$2);}
	|IMAGE UNSIGNED{
	#line 8107 "format.w"
	hset_max(image_kind,$2);}
	|LEADERS UNSIGNED{
	#line 8108 "format.w"
	hset_max(leaders_kind,$2);}
	|BASELINE UNSIGNED{
	#line 8109 "format.w"
	hset_max(baseline_kind,$2);}
	|XDIMEN UNSIGNED{
	#line 8110 "format.w"
	hset_max(xdimen_kind,$2);}
	|PARAM UNSIGNED{
	#line 8111 "format.w"
	hset_max(param_kind,$2);}
	|STREAMDEF UNSIGNED{
	#line 8112 "format.w"
	hset_max(stream_kind,$2);}
	|PAGE UNSIGNED{
	#line 8113 "format.w"
	hset_max(page_kind,$2);}
	|RANGE UNSIGNED{
	#line 8114 "format.w"
	hset_max(range_kind,$2);}
	|LABEL UNSIGNED{
	#line 8115 "format.w"
	hset_max(label_kind,$2);};

	/*:370*/	/*378:*/
def_node:
start FONT ref font END{
	#line 8315 "format.w"
	DEF($$,font_kind,$3);hput_tags($1,$4);}
	|start INTEGER ref integer END{
	#line 8316 "format.w"
	DEF($$,int_kind,$3);hput_tags($1,hput_int($4));}
	|start DIMEN ref dimension END{
	#line 8317 "format.w"
	DEF($$,dimen_kind,$3);hput_tags($1,hput_dimen($4));}
	|start LANGUAGE ref string END{
	#line 8318 "format.w"
	DEF($$,language_kind,$3);hput_string($4);hput_tags($1,TAG(language_kind,0));}
	|start GLUE ref glue END{
	#line 8319 "format.w"
	DEF($$,glue_kind,$3);hput_tags($1,hput_glue(&($4)));}
	|start XDIMEN ref xdimen END{
	#line 8320 "format.w"
	DEF($$,xdimen_kind,$3);hput_tags($1,hput_xdimen(&($4)));}
	|start RULE ref rule END{
	#line 8321 "format.w"
	DEF($$,rule_kind,$3);hput_tags($1,hput_rule(&($4)));}
	|start LEADERS ref leaders END{
	#line 8322 "format.w"
	DEF($$,leaders_kind,$3);hput_tags($1,TAG(leaders_kind,$4));}
	|start BASELINE ref baseline END{
	#line 8323 "format.w"
	DEF($$,baseline_kind,$3);hput_tags($1,TAG(baseline_kind,$4));}
	|start LIGATURE ref ligature END{
	#line 8324 "format.w"
	DEF($$,ligature_kind,$3);hput_tags($1,hput_ligature(&($4)));}
	|start DISC ref disc END{
	#line 8325 "format.w"
	DEF($$,disc_kind,$3);hput_tags($1,hput_disc(&($4)));}
	|start IMAGE ref image END{
	#line 8326 "format.w"
	DEF($$,image_kind,$3);hput_tags($1,TAG(image_kind,$4));}
	|start PARAM ref parameters END{
	#line 8327 "format.w"
	DEF($$,param_kind,$3);hput_tags($1,hput_list($1+2,&($4)));}
	|start PAGE ref page END{
	#line 8328 "format.w"
	DEF($$,page_kind,$3);hput_tags($1,TAG(page_kind,0));};
	/*:378*/	/*380:*/
def_node:
start INTEGER ref ref END{
	#line 8347 "format.w"
	DEF_REF($$,int_kind,$3,$4);hput_tags($1,TAG(int_kind,0));}
	|start DIMEN ref ref END{
	#line 8348 "format.w"
	DEF_REF($$,dimen_kind,$3,$4);hput_tags($1,TAG(dimen_kind,0));}
	|start GLUE ref ref END{
	#line 8349 "format.w"
	DEF_REF($$,glue_kind,$3,$4);hput_tags($1,TAG(glue_kind,0));};
	/*:380*/	/*385:*/
def_list:position
	|def_list def_node{
	#line 8465 "format.w"
	check_param_def(&($2));};
parameters:estimate def_list{
	#line 8466 "format.w"
	$$.p= $2;$$.t= TAG(param_kind,b001);$$.s= (hpos-hstart)-$2;};
	/*:385*/	/*386:*/
named_param_list:start PARAM parameters END
{
	#line 8479 "format.w"
	hput_tags($1,hput_list($1+1,&($3)));};
param_list:named_param_list	|start parameters END
{
	#line 8481 "format.w"
	hput_tags($1,hput_list($1+1,&($2)));};
	/*:386*/	/*394:*/

font:font_head font_param_list;

font_head:string dimension UNSIGNED UNSIGNED
{
	#line 8627 "format.w"
	uint8_t f= $<u>0;SET_DBIT(f,font_kind);hfont_name[f]= strdup($1);$$= hput_font_head(f,hfont_name[f],$2,$3,$4);};

font_param_list:glue_node disc_node	|font_param_list font_param;

font_param:
start PENALTY fref penalty END{
	#line 8632 "format.w"
	hput_tags($1,hput_int($4));}
	|start KERN fref kern END{
	#line 8633 "format.w"
	hput_tags($1,hput_kern(&($4)));}
	|start LIGATURE fref ligature END{
	#line 8634 "format.w"
	hput_tags($1,hput_ligature(&($4)));}
	|start DISC fref disc END{
	#line 8635 "format.w"
	hput_tags($1,hput_disc(&($4)));}
	|start GLUE fref glue END{
	#line 8636 "format.w"
	hput_tags($1,hput_glue(&($4)));}
	|start LANGUAGE fref string END{
	#line 8637 "format.w"
	hput_string($4);hput_tags($1,TAG(language_kind,0));}
	|start RULE fref rule END{
	#line 8638 "format.w"
	hput_tags($1,hput_rule(&($4)));}
	|start IMAGE fref image END{
	#line 8639 "format.w"
	hput_tags($1,TAG(image_kind,$4));};

fref:ref{
	#line 8641 "format.w"
	RNG("Font parameter",$1,0,MAX_FONT_PARAMS);};
	/*:394*/	/*398:*/
xdimen_ref:ref{
	#line 8718 "format.w"
	REF(xdimen_kind,$1);};
param_ref:ref{
	#line 8719 "format.w"
	REF(param_kind,$1);};
stream_ref:ref{
	#line 8720 "format.w"
	REF_RNG(stream_kind,$1);};


content_node:
start PENALTY ref END{
	#line 8724 "format.w"
	REF(penalty_kind,$3);hput_tags($1,TAG(penalty_kind,0));}
	|start KERN explicit ref END
{
	#line 8726 "format.w"
	REF(dimen_kind,$4);hput_tags($1,TAG(kern_kind,($3)?b100:b000));}
	|start KERN explicit XDIMEN ref END
{
	#line 8728 "format.w"
	REF(xdimen_kind,$5);hput_tags($1,TAG(kern_kind,($3)?b101:b001));}
	|start GLUE ref END{
	#line 8729 "format.w"
	REF(glue_kind,$3);hput_tags($1,TAG(glue_kind,0));}
	|start LIGATURE ref END{
	#line 8730 "format.w"
	REF(ligature_kind,$3);hput_tags($1,TAG(ligature_kind,0));}
	|start DISC ref END{
	#line 8731 "format.w"
	REF(disc_kind,$3);hput_tags($1,TAG(disc_kind,0));}
	|start RULE ref END{
	#line 8732 "format.w"
	REF(rule_kind,$3);hput_tags($1,TAG(rule_kind,0));}
	|start IMAGE ref END{
	#line 8733 "format.w"
	REF(image_kind,$3);hput_tags($1,TAG(image_kind,0));}
	|start LEADERS ref END{
	#line 8734 "format.w"
	REF(leaders_kind,$3);hput_tags($1,TAG(leaders_kind,0));}
	|start BASELINE ref END{
	#line 8735 "format.w"
	REF(baseline_kind,$3);hput_tags($1,TAG(baseline_kind,0));}
	|start LANGUAGE REFERENCE END{
	#line 8736 "format.w"
	REF(language_kind,$3);hput_tags($1,hput_language($3));};

glue_node:start GLUE ref END{
	#line 8738 "format.w"
	REF(glue_kind,$3);
	if($3==zero_skip_no){hpos= hpos-2;$$= false;}
	else{hput_tags($1,TAG(glue_kind,0));$$= true;}};

	/*:398*/	/*425:*/
content_section:START CONTENT{
	#line 9185 "format.w"
	hput_content_start();}content_list END
{
	#line 9186 "format.w"
	hput_content_end();hput_range_defs();hput_label_defs();};
	/*:425*/
%%
	/*:534*/
